/*
 * Copyright (c) 1993 Addison-Wesley Publishing Company.
 * All rights reserved.  This source code is provided
 * for its instructional value, and is not guaranteed
 * for any particular purpose.
 */
#include <rpc/rpc.h>
#include <stdio.h>
#include <stdlib.h>
#include "mtype.h"

void
main(int argc, char *argv[])
{
	char **machtype;
	CLIENT *handle;

	if (argc != 2) {
		fprintf(stderr, "usage: %s hostname\n", argv[0]);
		exit(1);
	}
	machtype = NULL;

	/*
	 * Create a client handle.
	 */
	handle = clnt_create(argv[1], MACH_PROG, MACH_VERS,
	  "netpath");
	if (handle == NULL) {
		fprintf(stderr,
		  "%s: can't create client handle: %s\n",
		  argv[0], clnt_spcreateerror(""));
		exit(1);
	}

	/*
	 * Make the remote procedure call.
	 */
	machtype = mach_proc_1(NULL, handle);
	if (machtype == NULL) {
		/*
		 * RPC failed.  Print an error message.
		 */
		fprintf(stderr, "%s: %s\n", argv[0],
		  clnt_sperror(handle, "rpc failed"));
		exit(1);
	} else {
		/*
		 * RPC succeeded.  Print the string returned.
		 */
		printf("machine type is %s\n", *machtype);
		exit(0);
	}
}
